//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "binSample.h"
//---------------------------------------------------------------------------
#pragma link "VBMCOM32"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnError(TObject *Sender, short MajorErrorCode,
	int MinorErrorCode)
{
  char szMsg[128];
  wsprintf(szMsg,"%d %d\n",MajorErrorCode, MinorErrorCode);
  OutputDebugString(szMsg);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnRecv(TObject *Sender, AnsiString &strRecv)
{
  char szMsg[256];
  char szTmp[128];
  int  i;
  char* pch = strRecv.c_str();

  strcpy(szMsg,"r: ");
  for( i = 0; i < (int)strlen(pch); i++ )
  {
    wsprintf(szTmp, "%x ", *(pch+i));
    strcat(szMsg, szTmp);
  }
  OutputDebugString(szMsg);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnSendBinaryClick(TObject *Sender)
{
  int rc;
  int i;
  Variant v;
  int Bounds[2];

  Bounds[0] = 0;
  Bounds[1] = 255;
  v = VarArrayCreate( Bounds, 1, varByte );
  for(i=0; i <= 255; i++)
  {
    Variant& vTmp = Byte(i);
    v.PutElement(vTmp,i);
  }

  rc = Vbmcomm1->SendBinaryBytes(v);
  if( rc )
  {
    char szMsg[128];
    wsprintf(szMsg,"Error %d\n",rc);
    OutputDebugString(szMsg);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnRecvBinaryClick(TObject *Sender)
{
  int rc;
  int i;
  Variant v;
  int Bounds[2];

  Bounds[0] = 0;
  Bounds[1] = 255;
  v = VarArrayCreate( Bounds, 1, varByte );

  rc = Vbmcomm2->RecvBinaryBytes(v,0);
  if( rc )
  {
    char szMsg[128];
    wsprintf(szMsg,"Recv Error %d\n",rc);
    OutputDebugString(szMsg);
  }

  for (i=0; i <= 255; i++)
  {
    int n = v.GetElement(i);
    char szTmp[128];
    sprintf(szTmp,"%d",n);
    ListBox1->Items->Add(szTmp);
  }
}
//---------------------------------------------------------------------------